#! /usr/bin/env node
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

require("@babel/polyfill");

var _commander = _interopRequireDefault(require("commander"));

var _nodeToolkit = require("@tech_query/node-toolkit");

var _utility = require("./utility");

var _command = require("./command");

var _puppeteerBrowser = _interopRequireDefault(require("puppeteer-browser"));

/* babel-plugin-inline-import '../package.json' */
const config = "{\n  \"name\": \"web-cell-cli\",\n  \"version\": \"1.0.0-alpha\",\n  \"description\": \"Developer command-line tool for WebCell\",\n  \"keywords\": [\n    \"developer\",\n    \"command-line\",\n    \"web-cell\",\n    \"component\",\n    \"package\",\n    \"bundle\"\n  ],\n  \"author\": \"shiy2008@gmail.com\",\n  \"license\": \"AGPL-3.0\",\n  \"homepage\": \"https://web-cell.tk/DevCLI/\",\n  \"repository\": {\n    \"type\": \"git\",\n    \"url\": \"git+https://github.com/EasyWebApp/DevCLI.git\"\n  },\n  \"bugs\": {\n    \"url\": \"https://github.com/EasyWebApp/DevCLI/issues\"\n  },\n  \"module\": \"source/Component.js\",\n  \"main\": \"dist/Component.js\",\n  \"bin\": {\n    \"web-cell\": \"dist/index.js\"\n  },\n  \"directories\": {\n    \"lib\": \"source\",\n    \"test\": \"test\"\n  },\n  \"engines\": {\n    \"node\": \"^6.3.0\"\n  },\n  \"scripts\": {\n    \"test\": \"mocha --exit\",\n    \"debug\": \"mocha --inspect-brk\",\n    \"lint\": \"eslint source/ test/ --fix\",\n    \"pack\": \"babel source/ -d dist/ -s --ignore source/install.js\",\n    \"prepublishOnly\": \"npm test  &&  npm run lint  &&  npm run pack\",\n    \"build\": \"npm run prepublishOnly  &&  esdoc\",\n    \"start\": \"web-server docs/ -o\",\n    \"install\": \"node source/install\"\n  },\n  \"husky\": {\n    \"hooks\": {\n      \"pre-commit\": \"npm run build  &&  git add .\"\n    }\n  },\n  \"dependencies\": {\n    \"@babel/polyfill\": \"^7.2.5\",\n    \"@babel/runtime\": \"^7.3.4\",\n    \"@tech_query/node-toolkit\": \"^0.9.2\",\n    \"amd-bundle\": \"^1.7.7\",\n    \"commander\": \"^2.19.0\",\n    \"dom-renderer\": \"^0.8.0\",\n    \"fs-extra\": \"^7.0.1\",\n    \"jsdom\": \"^13.2.0\",\n    \"less\": \"^3.9.0\",\n    \"puppeteer-browser\": \"^0.3.7\",\n    \"sass\": \"^1.17.2\",\n    \"stylus\": \"^0.54.5\",\n    \"yaml\": \"^1.3.2\"\n  },\n  \"peerDependencies\": {\n    \"@babel/plugin-proposal-decorators\": \"^7.3.0\",\n    \"@babel/preset-env\": \"^7.3.4\",\n    \"web-cell\": \"^1.0.0-alpha\"\n  },\n  \"devDependencies\": {\n    \"@babel/cli\": \"^7.2.3\",\n    \"@babel/core\": \"^7.3.4\",\n    \"@babel/plugin-proposal-decorators\": \"^7.3.0\",\n    \"@babel/plugin-transform-runtime\": \"^7.3.4\",\n    \"@babel/preset-env\": \"^7.3.4\",\n    \"@babel/register\": \"^7.0.0\",\n    \"babel-eslint\": \"^10.0.1\",\n    \"babel-plugin-inline-import\": \"^3.0.0\",\n    \"esdoc\": \"^1.1.0\",\n    \"esdoc-ecmascript-proposal-plugin\": \"^1.0.0\",\n    \"esdoc-external-webapi-plugin\": \"^1.0.0\",\n    \"esdoc-standard-plugin\": \"^1.0.0\",\n    \"eslint\": \"^5.14.1\",\n    \"husky\": \"^1.3.1\",\n    \"koapache\": \"^1.0.6\",\n    \"mocha\": \"^6.0.2\",\n    \"should\": \"^13.2.3\"\n  }\n}\n";
const meta = JSON.parse(config),
      folder = (0, _utility.folderOf)();

function safePack(_x) {
  return _safePack.apply(this, arguments);
}

function _safePack() {
  _safePack = (0, _asyncToGenerator2.default)(function* (exit) {
    try {
      yield (0, _command.pack)(folder.lib);
    } catch (error) {
      console.error(error);
      if (exit === true) process.exit(1);
    }
  });
  return _safePack.apply(this, arguments);
}

_commander.default.name('web-cell').version(meta.version).description(meta.description).command('boot [path] [options]', 'Boot a directory as a WebCell project').on('command:boot', parameter => (0, _nodeToolkit.spawn)('npm', ['init', 'web-cell'].concat(parameter), {
  stdio: 'inherit'
})).command('new <name> [attributes]', `Create a Component from Code template
                         (Attributes should be separated by commas)`).on('command:new', ([name, keys]) => (0, _command.create)(name, folder.lib, (keys || '').split(','))).command('pack', 'Bundle components to a package with JS modules in it').on('command:pack', safePack.bind(null, true)).command('preview', 'Real-time preview during development').on('command:preview',
/*#__PURE__*/
(0, _asyncToGenerator2.default)(function* () {
  yield safePack(true);
  yield _puppeteerBrowser.default.getPage('.', folder.test || 'test/', safePack);
})).parse(process.argv);
//# sourceMappingURL=index.js.map