"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.css = css;
exports.less = less;
exports.sass = sass;
exports.stylus = stylus;
exports.yaml = yaml;
exports.scss = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _less2 = _interopRequireDefault(require("less"));

var SASS = _interopRequireWildcard(require("sass"));

var _stylus = _interopRequireDefault(require("stylus"));

var _yaml = _interopRequireDefault(require("yaml"));

/**
 * @private
 *
 * @param {String} raw
 *
 * @return {String}
 */
function css(raw) {
  return raw;
}
/**
 * @private
 *
 * @param {String} raw
 * @param {String} path
 * @param {Object} [option] - http://lesscss.org/usage/#less-options
 *
 * @return {String}
 */


function less(_x, _x2, _x3) {
  return _less.apply(this, arguments);
}
/**
 * @private
 *
 * @param {String} raw
 * @param {String} path
 * @param {Object} [option] - https://github.com/sass/node-sass#options
 *
 * @return {String}
 */


function _less() {
  _less = (0, _asyncToGenerator2.default)(function* (raw, path, option) {
    return (yield _less2.default.render(raw, (0, _objectSpread2.default)({
      paths: [path]
    }, option))).css;
  });
  return _less.apply(this, arguments);
}

function sass(raw, path, option) {
  return SASS.renderSync((0, _objectSpread2.default)({
    data: raw,
    includePaths: [path]
  }, option)).css;
}
/**
 * @private
 *
 * @type {Function}
 */


const scss = sass;
/**
 * @private
 *
 * @param {string} raw
 * @param {String} path
 * @param {Object} [option] - https://github.com/stylus/stylus/blob/HEAD/docs/js.md
 *
 * @return {Promise<string>} CSS source code
 */

exports.scss = scss;

function stylus(raw, path, option = {}) {
  return new Promise((resolve, reject) => _stylus.default.render(raw, (0, _objectSpread2.default)({
    paths: [path]
  }, option), (error, CSS) => error ? reject(error) : resolve(CSS)));
}
/**
 * @private
 *
 * @param {String} raw
 * @param {Object} [option] - https://eemeli.org/yaml/#options
 *
 * @return {String}
 */


function yaml(raw, option) {
  return _yaml.default.parse(raw, option);
}
//# sourceMappingURL=parser.js.map