"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.index_html = index_html;
exports.index_js = index_js;

var _nodeToolkit = require("@tech_query/node-toolkit");

var _utility = require("./utility");

/**
 * @private
 *
 * @return {String}
 */
function index_html() {
  return `<template>
    <style>
        h1 {
            color: lightblue;
        }
    </style>

    <h1>Hello, WebCell !</h1>
</template>`;
}
/**
 * @private
 *
 * @param {String}   name
 * @param {String[]} [keys=[]]
 *
 * @return {String}
 */


function index_js(name, keys = []) {
  return (0, _nodeToolkit.prettify)(`
import { component${keys[0] ? ', mapProperty, mapData' : ''} } from 'web-cell';

import template from './index.html';


@component({ template })
export default  class ${(0, _utility.identifierOf)(name, true)} extends HTMLElement {

    constructor() {  super().construct();  }
${keys[0] ? `
    @mapProperty
    static get observedAttributes() {

        return  ${JSON.stringify(keys)};
    }

    @mapData
    attributeChangedCallback() { }` : ''}
}`);
}
//# sourceMappingURL=template.js.map