"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.identifierOf = identifierOf;
exports.folderOf = exports.metaOf = void 0;

var _nodeToolkit = require("@tech_query/node-toolkit");

/**
 * @param {String}   raw
 * @param {?Boolean} big - Big-camel style
 *
 * @return {String}
 */
function identifierOf(raw, big) {
  raw = raw.replace(/\W+(\w)/g, (_, char) => char.toUpperCase()).replace(/^\d/, char => '_' + char);
  return big ? raw[0].toUpperCase() + raw.slice(1) : raw;
}
/**
 * Get `package.json` data of `path` or `process.cwd()`
 *
 * @type {function(path: ?String): Object}
 */


const metaOf = (0, _nodeToolkit.cache)(path => ((0, _nodeToolkit.packageOf)(path || './test') || '').meta || {});
/**
 * Get `directories` field of `package.json` in `path` or `process.cwd()`
 *
 * @type {function(path: ?String): Object}
 */

exports.metaOf = metaOf;
const folderOf = (0, _nodeToolkit.cache)(path => (metaOf(path) || '').directories || {});
exports.folderOf = folderOf;
//# sourceMappingURL=utility.js.map